;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; File:         header for PSL kernel, WINDOWS interface

 jmp   windows_entry

   ALIGN 4

__puffer     dd 100 dup(0)
__spointer_low   DD 0    ; state of esp when entering from 16-bit
__spointer_high  DD 0    ;
__heapsize   DD 0
__stacksize  DD 0
__dataseg    DW 0
__stackseg   DW 0
__s16seg     DW 0
__psllcall   DW 0
             DW 0     ; upper half for 32 bit address
__c16seg     DW 0
__psllmain   DW 0
             DW 0    
             DW 0
__mode       DW 0
__pspseg     DW 0
windows_entry:
 
 cmp   bx,4712
 je    windows_alarm
 mov   ebp,esp
 mov   ax,WORD ptr [ebp+16]    ; ds
 mov   ds,eax
 mov   ds:__spointer_low,esp
 mov   ds:__s16seg,es          ; 16 bit stack segment
 mov   gs,ds:__s16seg
  ;;   db     0cbh      ; far ret  
 mov   eax,DWORD PTR [ebp+8]
 mov   DWORD PTR ds:__heapsize,eax
 mov   eax,DWORD ptr [ebp+12]
 mov   DWORD ptr ds:__stacksize,eax
 sub   eax,4
 mov   esp,eax
 mov   ax,WORD ptr [ebp+16]
 mov   WORD ptr ds:__dataseg,ax
 mov   ax,WORD ptr [ebp+18]
 mov   WORD ptr ds:__stackseg,ax
 mov   ax,WORD ptr [ebp+20]
 mov   WORD ptr ds:__c16seg,ax
 mov   WORD ptr ds:__psllmain+4,ax
 mov   ax,WORD ptr [ebp+22]
 mov   WORD ptr ds:__psllcall,ax
 mov   ax,WORD ptr [ebp+24]
 mov   WORD ptr ds:__psllmain,ax
 sub   eax,eax
 mov   WORD ptr ds:__psllcall+2,ax
 mov   WORD ptr ds:__psllmain+2,ax
 mov   ax,WORD ptr [ebp+26]
 mov   WORD ptr ds:__pspseg,ax
 mov   ax,WORD ptr [ebp+28]
 mov   WORD ptr ds:__mode,ax

 mov   eax,1
 mov   DWORD ptr ds:windows,eax

  ; preparing parameters for PSL kernel

 mov   ecx,__heapsize
 mov   ebx,0
 mov   bx,__mode
 mov   edx,0
 mov   dx,__pspseg
  sub  esp,200
  jmp mainw
 
 ;  db     0cbh      ; far ret
 
windows_alarm:
 mov   ebx,es        ; that is our data segment
 mov   ds,ebx
 mov   eax,ecx
 shl   eax,16        ; reconstruct handler address
 shr   eax,16
 shl   edx,16
 or    eax,edx       
 jmp   eax


console_print_string:
 mov  edx,1
 jmp  psll_call

meldung: db " Meldung Nummer ",0

melden:
 push eax
 lea  eax,meldung
 call console_print_string
 pop eax
 mov edx,2
 call psll_call
 mov edx,4
 call psll_call
 ret

 ;;;   call of WIN main loop:
 ;;;    par 1:   if <=0, exit
 ;;;             else: buffer for new "terminal" input line

psll_main:
 mov   DWORD ptr ds:__spointer_high,esp
    ; ensure that we are in a 16-bit addressable portion of the stack
 cmp  esp,0fffh
 jl   psll_main_1
 mov   esp,0ff0h
psll_main_1:
 push  eax
 
 ; call  far [__psllcall]
 lea   eax,__psllmain
 db   255,18h
 mov   esp,DWORD ptr ds:__spointer_high
 shl eax,16        ; convert long return value to 32 bit number
 shr eax,16
 shl edx,16
 or eax,edx
 mov   gs,ds:__s16seg       
 ret 

 ;;;   call of 16 bit subroutine: 
 ;;;     1-3: standard parameters
 ;;;     4:   operation code
psll_call:
 mov   DWORD ptr ds:__spointer_high,esp
    ; ensure that we are in a 16-bit addressable portion of the stack
 cmp  esp,0fffh
 jl   psll_call_1
 mov   esp,0ff0h
psll_call_1:
 push  edx
 push  ecx
 push  ebx
 push  eax
 
 ; call  far [__psllcall]
 lea   eax,__psllcall
 db   255,18h
 
 mov   esp,DWORD ptr ds:__spointer_high
 shl eax,16        ; convert long return value to 32 bit number
 shr eax,16
 shl edx,16
 or eax,edx
 mov   gs,ds:__s16seg       
 ret 

windows        DD 0    ; 

;;
;;  end of PSL kernel header include file
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

