%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:           disassemble.SL
% Title:          DEC Alpha disassembler 
% Author:         Winfried Neun, ZIB Berlin
% Created:        19 November 1988
% Status:         Experimental
% Mode:           Lisp
% Package:        Compiler
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% main driver
%            either  (disassemble 'hugo)      or
%                    (disassemble '16#4711)

(compiletime (put 'load-long 'opencode
                        '((ldl (reg 1) (displacement (reg 1) 0)))))

(de disassemble (fkt)
   (prog (word i name)  
      
     (setq name fkt)
     (when (idp fkt) (when (funboundp fkt) (error 0 (list fkt "not compiled")))
                (setq fkt (symfnc (idinf fkt))))

     (setq outputbase* 16)
     (prin2l (list "**** Function :" name " at " fkt)) (terpri) (terpri)
     (setq outputbase* 10 i 0)
  loop1                      % first pass picking labels only
     (setq word (load-long (wplus2 fkt (wtimes2 4 i))))
     (when (eq 0 word) (go loopex)) % finish at UNIMP
     (setq i (wplus2 1 i))
     (go loop1)
   loopex
     (echoon fkt i fkt 0)
)   ) 

