%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:           vector-Helferlein.SL
% Description:    useful diagnostic functions conserving vector regs
% Author:         Herbert Melenk and Winfried Neun, ZIB Berlin
% Created:        5 March 1987
% Status:         Experimental (Do Not Distribute), CRAY version only
% Mode:           Lisp
% Package:        Utilities
%
% Copyright (c) 1987, Konrad Zuse-Zentrum Berlin, all rights reserved
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
(compiletime (load inum vector-instructions))
 
%       testvehicle
%       safe dump of vector registers
%       vldump:
%         1st parameter: actual vector length
%         2nd parameter: an arbitrary string printed as heading
 
(fluid '(vsave0 vsave1 vsave2 vsave3 vsave4 vsave5 vsave6 vsave7))
 
(setq vsave0 (mkwrds (gtwrds 64)))
(setq vsave1 (mkwrds (gtwrds 64)))
(setq vsave2 (mkwrds (gtwrds 64)))
(setq vsave3 (mkwrds (gtwrds 64)))
(setq vsave4 (mkwrds (gtwrds 64)))
(setq vsave5 (mkwrds (gtwrds 64)))
(setq vsave6 (mkwrds (gtwrds 64)))
(setq vsave7 (mkwrds (gtwrds 64)))
 
(de vdump (vl text)
    (when (wgeq vl 64) (setq vl 64))
    (vsetvl 64)
    (vstore (Vreg 0) (aplus2 vsave0 2) 1)
    (vstore (Vreg 1) (aplus2 vsave1 2) 1)
    (vstore (Vreg 2) (aplus2 vsave2 2) 1)
    (vstore (Vreg 3) (aplus2 vsave3 2) 1)
    (vstore (Vreg 4) (aplus2 vsave4 2) 1)
    (vstore (Vreg 5) (aplus2 vsave5 2) 1)
    (vstore (Vreg 6) (aplus2 vsave6 2) 1)
    (vstore (Vreg 7) (aplus2 vsave7 2) 1)
    (Console-print-string text)
    (console-newline)
    (print-vreg "Vreg 0" vsave0 vl)
    (print-vreg "Vreg 1" vsave1 vl)
    (print-vreg "Vreg 2" vsave2 vl)
    (print-vreg "Vreg 3" vsave3 vl)
    (print-vreg "Vreg 4" vsave4 vl)
    (print-vreg "Vreg 5" vsave5 vl)
    (print-vreg "Vreg 6" vsave6 vl)
    (print-vreg "Vreg 7" vsave7 vl)
    (vsetvl 64)
    (vload (Vreg 0) (aplus2 vsave0 2) 1)
    (vload (Vreg 1) (aplus2 vsave1 2) 1)
    (vload (Vreg 2) (aplus2 vsave2 2) 1)
    (vload (Vreg 3) (aplus2 vsave3 2) 1)
    (vload (Vreg 4) (aplus2 vsave4 2) 1)
    (vload (Vreg 5) (aplus2 vsave5 2) 1)
    (vload (Vreg 6) (aplus2 vsave6 2) 1)
    (vload (Vreg 7) (aplus2 vsave7 2) 1)
    (vsetvl vl)
 )
 
(de vprint (vl item)
    (when (wgeq vl 64) (setq vl 64))
    (vsetvl 64)
    (vstore (Vreg 0) (aplus2 vsave0 2) 1)
    (vstore (Vreg 1) (aplus2 vsave1 2) 1)
    (vstore (Vreg 2) (aplus2 vsave2 2) 1)
    (vstore (Vreg 3) (aplus2 vsave3 2) 1)
    (vstore (Vreg 4) (aplus2 vsave4 2) 1)
    (vstore (Vreg 5) (aplus2 vsave5 2) 1)
    (vstore (Vreg 6) (aplus2 vsave6 2) 1)
    (vstore (Vreg 7) (aplus2 vsave7 2) 1)
    (eval item)
    (vsetvl 64)
    (vload (Vreg 0) (aplus2 vsave0 2) 1)
    (vload (Vreg 1) (aplus2 vsave1 2) 1)
    (vload (Vreg 2) (aplus2 vsave2 2) 1)
    (vload (Vreg 3) (aplus2 vsave3 2) 1)
    (vload (Vreg 4) (aplus2 vsave4 2) 1)
    (vload (Vreg 5) (aplus2 vsave5 2) 1)
    (vload (Vreg 6) (aplus2 vsave6 2) 1)
    (vload (Vreg 7) (aplus2 vsave7 2) 1)
    (vsetvl vl)
 )
 
(de print-vreg (vreg save vl)
    (console-print-string vreg)
    (ifor (from i 1 vl 3)
          (do (putoct (getmem (aplus2 save
                                      (wplus2 i 1))))
              (terminalwritechar 32 32)
              (putoct (getmem (aplus2 save
                                      (wplus2 i 2))))
              (terminalwritechar 32 32)
              (putoct (getmem (aplus2 save
                                      (wplus2 i 3))))
              (console-newline) ))
    (console-newline)
)
 
(de hilfe (l text1 text2 )
  (vprint l `(console-print-string ,text1))
  (vprint l text2)
  (vprint l `(console-newline)) )
 
